package com.javacodegeeks.helloworld.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.safehtml.shared.SafeHtml;
import com.google.gwt.safehtml.shared.SafeHtmlUtils;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.HTMLPanel;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.PasswordTextBox;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.VerticalPanel;

/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class SampleWebApplication implements EntryPoint{

	/**
	 * This is the entry point method.
	 */
	public void onModuleLoad() {

		String html = 
				"<div id='LoginPage' name='LoginPage'>" +
						"<p id='uname' >" +
						"<label>UserName<br/>" +
						"</p>" +
						"<p id='password'>" +
						"<label>Password<br/>" +
						"</p>" +
						"<p id='submit' class='submit'>" +
						"</p>" +
						"</div>";

		HTMLPanel myPanel = new HTMLPanel(html);

		// The user-name field
		TextBox user = new TextBox();
		user.getElement().setId("user_name");
		myPanel.add(user, "uname");

		// The password field
		TextBox password = new PasswordTextBox();
		password.getElement().setId("user_password");
		myPanel.add(password, "password");

		// The log in button
		Button submit = new Button("Submit");
		submit.getElement().setId("submit");
		myPanel.add(submit, "submit");

		submit.addClickHandler(new ClickHandler() {

			@Override
			public void onClick(ClickEvent event) {
				// Add validation
				error("<table style='width:100%', border='1'><tr><th>Error Type</th><th>Error "
						+ "Description</th></tr><tr><td>  Fatal</td><td>  "
						+ "Incorrect Password</td></tr></table>");
			}
		});
		/*
		 * Add our panel to the page
		 */
		RootPanel.get().add(myPanel);
	}

	/**
	 * Custom Error Dialog Page. 
	 * @param err
	 */
	public void error(String err) {
		final DialogBox dialog = new DialogBox();dialog.center();
		dialog.setSize("80%", "80%");dialog.setText("Error");

		VerticalPanel panel = new VerticalPanel();panel.setSize("100%", "100%");
		HTMLPanel html = new HTMLPanel(err);html.setSize("100%", "100%");
		panel.add(html);

		Button ok = new Button("OK");
		VerticalPanel buttonPanel = new VerticalPanel(); buttonPanel.setSpacing(3);
		buttonPanel.add(ok);
		panel.add(buttonPanel);

		dialog.setWidget(panel);

		ok.addClickHandler(new ClickHandler() {

			public void onClick(ClickEvent arg0) {
				dialog.hide();
			}

		});
		dialog.show();
	}
	/**
	 * This is the entry point method.
	 * 
	 */
	public void onModuleLoad_Two(){

		// Create HTML Panel with given tag and its HTML value.
		HTMLPanel htmlPanelH1 = new HTMLPanel("h1", "Heading using HTML tag: h1");
		HTMLPanel htmlPanelH2 = new HTMLPanel("h2", "Heading using HTML tag: h2");
		HTMLPanel htmlPanelH3 = new HTMLPanel("h3", "Heading using HTML tag: h3");

		VerticalPanel vp = new VerticalPanel();
		vp.setSize("100%", "100%");vp.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_CENTER);
		vp.add(htmlPanelH1);
		vp.add(htmlPanelH2);
		vp.add(htmlPanelH3);
		// Add the HTML Panel to the root 	panel.
		RootPanel.get().add(vp);
	}

	/**
	 * This is the entry point method.
	 * 
	 */
	public void onModuleLoad_String() {

		// Create Safe HTML String.

		String  htmlString = "Example shows HTML Panel constructed through HTML String.<br><br>"
				+ "<table width='100%'border='1'>"
				+ "<tr>"
				+ "<th>FirstName</th><th>LastName</th><th>Age</th>"
				+ "</tr>"
				+ "<tr>"
				+ "<td>Bob</td><td>Sen</td><td>68</td>"
				+ "</tr>"
				+ "</table>";
		HTMLPanel htmlPanel = new HTMLPanel(htmlString);

		// Add the HTML Panel to the root 	panel.
		RootPanel.get().add(htmlPanel);
	}
	public void onModuleLoad_SafeHtml(){

		// Create Safe HTML String.

		SafeHtml safeHtml = SafeHtmlUtils.fromSafeConstant("Example shows HTML Panel constructed through HTML String.<br><br>"
				+ "<table width='100%'border='1'>"
				+ "<tr>"
				+ "<th>FirstName</th><th>LastName</th><th>Age</th>"
				+ "</tr>"
				+ "<tr>"
				+ "<td>Bob</td><td>Sen</td><td>68</td>"
				+ "</tr>"
				+ "</table>");
		HTMLPanel htmlPanel = new HTMLPanel(safeHtml);

		// Add the HTML Panel to the root 	panel.
		RootPanel.get().add(htmlPanel);
	}

}
